#include "Vram.h"
#include "VVram.h"
#include "Chars.h"

extern byte[] Backup;
extern byte[] MonoPattern, ColorPattern, LinePattern;

void InitVram()
{
    ClearScreen();
    MakePatternMono(Char_Ascii, MonoPattern, 0x40, 15);
    MakePatternMono(Char_Logo, MonoPattern + Char_Logo * 4, 16, 5);
    MakePatternMono(Char_Star, MonoPattern + Char_Star * 4, 2, 15);
    MakePatternMono(Char_EnemyBullet, MonoPattern + Char_EnemyBullet * 4, 1, 14);
    MakePatternColor(Char_Enemy, ColorPattern, Char_End - Char_Enemy);
}


word PrintC(word vram, byte c)
{
    return Put(vram, c - ' ');
}


word Put2C(word vram, byte c)
{
    repeat (2) {
        repeat (2) {
            vram = Put(vram, c);
            ++c;
        }
        vram += VramRowSize - 2 * VramStep;
    }
    return vram + 2 * VramStep - VramRowSize * 2;
}


word Erase2(word vram)
{
    repeat (2) {
        repeat (2) {
            vram = Put(vram, Char_Space);
        }
        vram += VramRowSize - 2 * VramStep;
    }
    return vram + 2 * VramStep - VramRowSize * 2;
}
